function [sol,fsol]=CRS(B,xmin,xmax,CRSMAX,CRSpm)
global stopall breachpoint evalu goppar goppars

% --- Inicializaciones caso particular
siB=size(B);
n=siB(2);  
N=siB(1);
alpha=CRSpm;
evalMAX=CRSMAX;
epsiMIN=0;

epsilon=(xmax-xmin)/50;



ordenar  = struct('clave',[],'posicion',[]);
Clustsup = struct('clave',[],'posicion',[]);
Clustinf = struct('clave',[],'posicion',[]);

% --- Inicializacin
convergencia=0; 
Pbien=0; Pmal=0;	peval=0; qeval=0;
evalmg=0;		    

% --- Los vectores "Clust*" los utilizamos para el criterio de parada. Sirven para determinar si la poblacin 
% ha convergido hacia una zona del espacio de bsqueda. Esto suceder cuando lmites inferiores y superiores se 
% encuentren muy cerca.
for i=1:n
    Clustsup(i).clave = xmin(i);    Clustsup(i).posicion = 0;
    Clustinf(i).clave = xmax(i);    Clustinf(i).posicion = 0;
    trozo(i) = (xmax(i)-xmin(i))/(N^(1/n));
    trozonorm(i) = (trozo(i))/((2^31)-1);  
end

raizN = N^(1/n);

% if  (goppar==1)&(goppars==1)
% 
%  for i=1:N
%     for j=2:n+1
%      		A(i,j) = B(i,j-1);%(value*trozonorm(j-1))+xmin(j-1)+(trozo(j-1)*incr);
%     end    
% end
% 
% 
% parfor i=1:N
%     Apar=A;
%     Apar(i,1) = userfunc(A(i,2:end));
%     ordenar(i).clave = Apar(i,1);
%     ordenar(i).posicion = i;    
% end   
%   for i=1:N
%        A(i,1)=ordenar(i).clave;
%   end  
% else
for i=1:N
    for j=2:n+1
        %incr = mod(round((i-1)/(N^((j-2)/n))) , round(raizN));
        %value = 1 + ((2^31)-1)* rand;  % Valor aleatorio entre 1 y 2^31. Equivalente a funcion lrand48() de C
		A(i,j) = B(i,j-1);%(value*trozonorm(j-1))+xmin(j-1)+(trozo(j-1)*incr);
    end

    [A(i,1),A(i,2:end)] = gopfunc(A(i,2:end));

    ordenar(i).clave = A(i,1);
    ordenar(i).posicion = i;
     
end
%end

for i=1:n+2 
    P(i)=0.0;
end 

for i=1:n+1 
    G(i)=0.0;
end

ordenar = gopordenarray(ordenar,N);

while (convergencia==0)&(((stopall==1)|(breachpoint==1))==0)
   
	    [Rn,G]=CALCULAR_G(G, A, N,n);
        [pert,P]=CALCULAR_P(P,G,Rn,xmin,xmax,n,A);
       
        while(pert==0)
            [Rn,G]=CALCULAR_G(G, A, N,n);
            [pert,P]=CALCULAR_P(P,G,Rn,xmin,xmax,n,A);
        end

		[P(1),P(2:n+1)] = gopfunc(P(2:n+1)); % --- Evaluar punto primario
        evalmg = evalmg + 1;         % --- Aumentar nmero de evaluaciones totales
  		peval = peval + 1;		     % --- Aumentar nmero de evaluaciones de puntos primarios
	    if (P (1) < ordenar(1).clave)
        	 Pbien = Pbien + 1;
             [ordenar, A, Clustsup,Clustinf ]= REEMPLAZAR(ordenar, n, N, xmax, xmin, P, A, Clustsup, Clustinf); 
             ordenar = gopordenarray(ordenar,N);
             [Clustsup, Clustinf] = CALCULARCLUSTER(n, N,A, Clustsup, Clustinf,xmax, xmin);
        else
             
             Pmal = Pmal + 1;
         	 if (Pbien/(Pbien+Pmal)<alpha)              % --- Test de porcentaje de xito
                [P] = CALCULAR_Q (n, N, G, A, P,Rn);    % --- Calcular punto secundario
                [P(1),P(2:n+1)] = gopfunc(P(2:n+1));              % --- Evaluar punto secundario
                qeval = qeval + 1;
                evalmg = evalmg + 1;
		        if (P(1)<ordenar(1).clave)
                       [ordenar, A, Clustsup,Clustinf ]= REEMPLAZAR(ordenar, n, N, xmax, xmin, P, A, Clustsup, Clustinf); 
                       ordenar = gopordenarray(ordenar,N);
                       [Clustsup, Clustinf] = CALCULARCLUSTER(n, N,A, Clustsup, Clustinf,xmax, xmin);
                        % ---Deberiamos escribir Pbien ++?? Mirar pseudocodigo Pilar
                end
             end %test porcentaje
        end  %end else
 	    [convergencia]= PARAR(evalmg,Clustsup,ordenar, Clustinf, n, N, epsilon,evalMAX,epsiMIN);  
    end % --- Fin del While  
    

     
    % --- Salida por pantalla
    %assignin('base','nombre_variable',variable);  %'base' se refiere a
    %este workspace
    
    %disp(' ');
	%disp(' --- POBLACIN FINAL (matriz A) ---') ;
    %disp (A);
    %disp('Vector ordenar'); 
    %for i=1:N 
    %    disp(ordenar(i).clave);
    %end
    
	i=ordenar(N).posicion;
    %disp ('Posicin en la poblacin A del mnimo encontrado: ');
    %disp (i);
    %disp ('Coordenadas y funcin objetivo del mnimo encontrado');
    %disp(A(i,3)); disp(A(i,2)); disp(A(i,1));  
    sol=A(i,2:end);
  
    fsol=A(i,1);
	%disp(' --- ESTADSTICAS ---');
    %disp('Nmero de evaluaciones: '); disp(evalmg);
    %disp('qeval: '); disp(qeval);
    %disp('peval: '); disp(peval);
    %disp('Pbien: '); disp(Pbien);
    %disp('Pmal: '); disp(Pmal);
    %disp('epsilon: '); disp(epsilon);
 	%disp('Clustsup (posicion): '); disp(Clustsup(2).posicion); disp(Clustsup(1).posicion);
    %disp('Clustsup (clave): ');    disp(Clustsup(2).clave); disp(Clustsup(1).clave);
    %disp('Clustinf (posicion): '); disp(Clustinf(2).posicion); disp(Clustinf(1).posicion);
    %disp('Clustinf (clave): ');    disp(Clustinf(2).clave); disp(Clustinf(1).clave);

   
end

function [Rn,G] = CALCULAR_G(G,A,N,n) 
   for j=1:n 
        G(j) = 0.0;
   end
   for l=1:n+1                     %Seleccionamos aleatoriamente n+1 puntos de la poblacion A
        %temporal = rand * (N - 1);
        value = 1 + ((2^31)-1)* rand;  % Valor aleatorio entre 1 y 2^31. Equivalente a funcion lrand48() de C
        temporal = value/((2^31) -1);
        temporal=temporal*(N-1); 
        k = floor (temporal)+1;  % Sumo '1' porque en Matlab los vectores empiezan por '1' 
        for j=1:n                % Calculamos el centroide G
           G(j) = A(k,j+1) + G(j); %G=(n+1)g, donde g es el centroide
        end 
   end
  
   value = 1 + ((2^31)-1)* rand;  % Valor aleatorio entre 1 y 2^31. Equivalente a funcion lrand48() de C
   temporal = value/((2^31) -1);
   temporal=temporal*(N-1);     
   Rn = floor (temporal) + 1;   % Sumo '1' porque en Matlab los vectores empiezan por '1' 
   G(n+1)= Rn;  	   
end

function [pertenece,P] = CALCULAR_P(P,G,Rn,xmin,xmax,n,A)  % P= 2g-Rn+1 = 2*G/n+1 -Rn+1
   pertenece=1;
   P(n+2)=0.0;
     
   for j=2:n+1
     if(pertenece~=0)
       	 P(j)=(2.0*(G(j-1)/(n+1))-A(Rn,j));
         if (P(j) < ( xmin(j-1) )|| ( P(j)>xmax(j-1) ) )
         		pertenece=0 ;         % Pertenece=1 si P est en V   
         end
     end
   end
end

function [P] = CALCULAR_Q (n, N, G, A, P,Rn)
    G(n+1)=N+10;
    P(n+1)=1;
   
    for j=2:n+1
         P(j)=( (G(j-1)/(n+1))+A(Rn,j) )/2.0;
    end
end
%--------------------------------------------------------------------------
function [Clustsup, Clustinf] = CALCULARCLUSTER(n, N,A, Clustsup, Clustinf,xmax, xmin)
    for j=2:n+1 
        if (Clustsup(j-1).clave == xmin(j-1)) 
           for i=1:N 
              if (A(i,j) > Clustsup(j-1).clave)
                   Clustsup(j-1).clave=A(i,j);
                   Clustsup(j-1).posicion=i;
              end
           end
        end
        if (Clustinf(j-1).clave == xmax(j-1)) 
           for i=1:N
              if (A(i,j)< Clustinf(j-1).clave)
                    Clustinf(j-1).clave=A(i,j);
                    Clustinf(j-1).posicion=i;
              end 
           end
        end
    end
end
%--------------------------------------------------------------------------

function [ordenar, A, Clustsup,Clustinf ]= REEMPLAZAR(ordenar, n, N, xmax, xmin, P, A, Clustsup, Clustinf) 
    if (P(1)<=ordenar(1).clave)
       	  posicion=ordenar(1).posicion;
       	  i=1;
       	  while ( (ordenar(i).clave > P(1)) && (i < N) )
              ordenar(i).clave=ordenar(i+1).clave;
              ordenar(i).posicion=ordenar(i+1).posicion;
              i = i+1;
          end
          ordenar(i-1).posicion=posicion;
          ordenar(i-1).clave=P(1); 
          i=posicion;
       	  for j=1:n+1 
              A(i,j)=P(j);
          end
       	  for j=1:n 
              if (Clustsup(j).posicion ==posicion)
                  Clustsup(j).clave=xmin(j);
              end
              if (Clustinf(j).posicion == posicion)
                  Clustinf(j).clave =xmax(j);
              end
          end
    end
end
%--------------------------------------------------------------------------

function  [stop]= PARAR(evalmg,Clustsup,ordenar, Clustinf, n, N, epsilon,evalMAX,epsiMIN)
    stop =0;
    fin = 1;
    rep=0;
    if ((rep==4*(n+1)*(N)) || (evalmg >= evalMAX) || (ordenar(1).clave-ordenar(N).clave)<epsiMIN) 
        stop = 1;
  
    else
        if (evalmg > N)
	      for j = 1:n
            if (epsilon(j)<(Clustsup(j).clave-Clustinf(j).clave))
		      fin=0;
		      break;
            end
          end
	      if (fin == 0) 
            stop=0;
          else 
		    stop=1;
          end
        
        else 
	       stop=0;
        end
    end
end
%--------------------------------------------------------------------------


    
