delete('Temporary.txt')
Gradcomp=0;

if (ndim==2)&(dessin==1)
    figure(figure2) 
begin(3)=plot3(xoptg(1),xoptg(2),costsaveming,'ko', ...
      'MarkerSize',15, ...
      'LineWidth',2, ...
      'EraseMode','none');
begin(4)=text(xoptg(1),xoptg(2),costsaveming,'   End', ...
      'Color',[0 0 0], ...
      'EraseMode','none');
  
  if (film==2)  
   MOV(MOVF)=getframe;
   MOVF=MOVF+1; 
  end
  
end

if (ndim==1)&(dessin==1)
    figure(figure2) 
text(xoptg(1),costsaveming,'\bullet END', ...
      'Color',[1. 0 0], ...
      'FontSize',18, ...
      'EraseMode','none');
  if (film==2)  
   MOV(MOVF)=getframe;
   MOVF=MOVF+1; 
end
end

if (converg==1)&(convw==1)  
    figure(figure3) 
    plot(xcoor,conv,xcoor,bestconv);
    legend('Convergence History','Convergence of the best solution')
    figure(figure1)
end

if (lt0==0)&(dessin==1) 
    set(surft0,'Visible','off');
end
if (lt1==0)&(dessin==1) 
    set(surft1,'Visible','off');
end
if (lt2==0)&(dessin==1) 
    set(surft2,'Visible','off');
end 
if (lgo==0)&(dessin==1) 
    set(surfgo,'Visible','off');
end
if (lvar==0)&(dessin==1) 
    set(surfvar,'Visible','off');
end
disp('______________________________________________________');
disp('Valeur finale de la fonctionnelle :')
disp(costsaveming)
disp('______________________________________________________');

if benchsave==0
if (gopgui==1)
set(PCF2,'String',evalu+evalg);
end

%delete('filename')
%save('filename')
cd(savedir);
save([fileresult '.mat' ]);
csvwrite([fileresult '.csv' ],xoptg)
fid = fopen([fileresult '.txt'],'w');
   fprintf(fid,'Final point:\n');
   fprintf(fid,'%0.12f\n ',xoptg);
   fprintf(fid,'Final functional value:\n');
   fprintf(fid,'%0.12f\n ',costsaveming);
 fclose(fid);

 fid = fopen([filebmo '.txt'],'a');
   fprintf(fid,'RUNNING DATA :\n \n');
   fprintf(fid,'LEVEL 2 : %0.0f\n ',iter2);
   fprintf(fid,'LEVEL 1 : %0.0f\n ',iter1);
   fprintf(fid,'LEVEL 0 : %0.0f\n ',iterbvp);
   fprintf(fid,'MIN. AL : %0.0f\n ',igr);
   tper=(iter2-1)*nbext1*nbbvp*nbgrad + (iter1-1)*nbbvp*nbgrad + (iterbvp-1)*nbgrad + igr-1;
    quo=floor((tper/tpertot)*100)+1;
   fprintf(fid,'Used : %0.0f\n ',quo);
   timegui=floor(cputime-timc);
   fprintf(fid,'Elapsed Time : %0.0f\n ',timegui);
   fprintf(fid,'Evaluation number : %0.0f\n ',evalu+evalg);
fclose(fid);   

   saveb=[xcoor;conv];  
   fid = fopen([fileconv '.pts'],'w');
   fprintf(fid,'%0.0f %1.12f\n',saveb);
   fclose(fid);
   saveb=[xcoor;bestconv]; 
   fid = fopen([filebconv '.pts'],'w');
   fprintf(fid,'%0.0f %1.12f\n',saveb);
   fclose(fid);
   if (gopgui==1)
   mailto=get(PCDMLA,'String');
   end
   if (length(mailto)~=0)
   try  
   sendmail(mailto, ['GOP results:' datestr(now,30)], 'Result files are joined to this mail...',{[fileresult '.mat' ],[fileresult '.txt']});
   catch
   errordlg('Please verify e-mail adress or system compatibility...','Mail not send');
   end
   end
   cd('..')
if (gopgui==1)
   set(PCA6,'String',costsaveming);   
end
if (mopt==4)
gopanimgen
end

if (film==1)|(film==2)
 movie2avi(MOV,filefilm,'fps',8);
end
try
useraffich
end
end