hold off
surfvar=0;
begin=0;
optsave=opt;
opt=0;
figure(figure5) 
 cla;
    
if (srndim==3)
    xxfig=0;
    yyfig=0;
    zzfig=0;
    valfig=0;
    x=0;
    y=0;
    prec(1)=(xmax(xsr1)-xmin(xsr1))/precisr;
    prec(2)=(xmax(xsr2)-xmin(xsr2))/precisr;
    prec(3)=(xmax(xsr3)-xmin(xsr3))/precisr;
   cla;
   x=xmin(xsr1):prec(1):xmax(xsr1);
   y=xmin(xsr2):prec(2):xmax(xsr2);
   z=xmin(xsr3):prec(3):xmax(xsr3);
   [xxfig,yyfig,zzfig]=meshgrid(x,y,z);
for i=1:precisr+1
   for j=1:precisr+1
       for k=1:precisr+1      
           [xxfig(1,i,1),yyfig(j,1,1),zzfig(1,1,k),xsr1,xsr2,xsr3,ndim,srndim];
        valfig(i,j,k)=gopuserfuncsr([xxfig(1,i,1),yyfig(j,1,1),zzfig(1,1,k),xsr1,xsr2,xsr3,ndim,srndim]);
       end  
   end
end

   xslice = [(xmin(xsr1)+xmax(xsr1))/2,xmax(xsr1)];
   yslice = [(xmin(xsr2)+xmax(xsr2))/2,xmax(xsr2)]; 
   zslice = [xmin(xsr3);(xmin(xsr3)+xmax(xsr3))/2];
   figure(figure5) 
   slice(xxfig,yyfig,zzfig,valfig,xslice,yslice,zslice);   
   hold on;
end 
    
if (srndim==2)
    xxfig=0;
    yyfig=0;
    zzfig=0;
    x=0;
    y=0;
    prec(xsr1)=(xmax(xsr1)-xmin(xsr1))/precisr;
    prec(xsr2)=(xmax(xsr2)-xmin(xsr2))/precisr;
   cla;
   xfi=xmin(xsr1):prec(xsr1):xmax(xsr1);
   yfi=xmin(xsr2):prec(xsr2):xmax(xsr2);
   [xxfig,yyfig]=meshgrid(xfi,yfi);
   
   for i=1:precisr+1
       for j=1:precisr+1 
         zzfig(i,j)=gopuserfuncsr([xxfig(j*(precisr+1)),yyfig(i),xsr1,xsr2,ndim,srndim]);
       end  
   end
   
   hsv2=hsv;
   hsv3=[hsv2(11:64,:); hsv2(1:10,:)];  
   figure(figure5) 
   surface(xxfig,yyfig,zzfig,'EdgeColor',[.8 .8 .8]);   
   view(10,55);
   colormap(hsv3);
  end 

if (srndim==1)  
   xxfig=0; 
   zzfig=0;
   plotedit on
   figure(figure5)
   prec=(xmax(xsr1)-xmin(xsr1))/precisr;
   cla;
   xxfig=xmin(xsr1):prec(1):xmax(xsr1);
   for i=1:precisr+1
    zzfig(i)=gopuserfuncsr([xxfig(i),xsr1,ndim,srndim]);
   end
   hold off
   figure(figure5) 
    plot(xxfig,zzfig);   
end   
hold on