function gopregister
warning off
global LUSER1 LUSER2 LUSER3 LUSER4 LICEN
try
delete('License.mat')
end

try
close(LICEN)
end

LICEN=figure('Name','GOP Registration', ...
       'NumberTitle','off', ...
       'MenuBar','none', ...
       'Visible','on');
   
c1=0 ;c2=0.65; 
uibuttongroup('visible','on','Position',[c1 c2-.05 1 .4]);
g1titrecadre= uibuttongroup('visible','on','Position',[c1+0 c2+.29 0.28 .06],'BackgroundColor',[1 1 1]);
g1titre=uicontrol( ...
      'Style','text', ...
      'Units','normalized','BackgroundColor',[1 1 1], ...
      'Position',[ c1+0.01 c2+0.3 0.25 0.03], ...
      'String', 'License Data');

  LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.01 c2+0.2 0.5 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'String','Name');
   LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.01 c2+0.1 0.5 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'String','Forename');
   LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.01 c2 0.5 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'String','License Type');
   LUSER1=uicontrol( ...
      'Style','edit', ...
      'Units','normalized', ...
      'Position',[ c1+0.4 c2+0.2 0.5 0.05], ...
      'BackgroundColor',[1. 1. 1.], ...
      'ForegroundColor',[0 0 0]);
   LUSER2=uicontrol( ...
      'Style','edit', ...
      'Units','normalized', ...
      'Position',[ c1+0.4 c2+0.1 0.5 0.05], ...
      'BackgroundColor',[1. 1. 1.], ...
      'ForegroundColor',[0 0 0]);
  LUSER3=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.4 c2+0 0.5 0.05], ...
      'BackgroundColor',[1. 1. 1.], ...
      'ForegroundColor',[0 0 0],...
      'String','GNU General Public License','Fontsize',10,'fontweight','b');
 
c1=0 ;c2=0.25; 
uibuttongroup('visible','on','Position',[c1 c2-.05 1 .4]);
g1titrecadre= uibuttongroup('visible','on','Position',[c1+0 c2+.29 0.28 .06],'BackgroundColor',[1 1 1]);
g1titre=uicontrol( ...
      'Style','text', ...
      'Units','normalized','BackgroundColor',[1 1 1], ...
      'Position',[ c1+0.01 c2+0.3 0.25 0.03], ...
      'String', 'Matlab informations');
LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.01 c2+0.2 0.5 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'String','Matlab Directory');
LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.355 c2+0.21 0.59 0.045], ...
      'ForegroundColor',[0 0 0],'String',matlabroot);
 LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.01 c2+0.15 0.5 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'String','Matlab version');
LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.355 c2+0.16 0.59 0.045], ...
      'ForegroundColor',[0 0 0],'String',version);
  
c1=0 ;c2=0.12; 
uibuttongroup('visible','on','Position',[c1 c2-.05 1 .3]);
g1titrecadre= uibuttongroup('visible','on','Position',[c1+0 c2+.19 0.28 .06],'BackgroundColor',[1 1 1]);
g1titre=uicontrol( ...
      'Style','text', ...
      'Units','normalized','BackgroundColor',[1 1 1], ...
      'Position',[ c1+0.01 c2+0.2 0.25 0.03], ...
      'String', 'Install Options');

LUSER=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.01 c2+0.1 0.5 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'String','Directory');
  
LUSER4=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ c1+0.355 c2+0.1 0.59 0.05],'String',cd);
  
PUSER10 = uicontrol('Style', 'pushbutton', 'String', 'Register',...
    'Units','normalized', ...
    'Position',[ 0.9 0 0.1 0.05], ...  
    'Callback', 'goprego;');

PUSER10 = uicontrol('Style', 'pushbutton', 'String', 'Help',...
    'Units','normalized', ...
    'Position',[ 0.8 0 0.1 0.05], ...  
    'Callback', 'open(''uguide.pdf'');');



PUSER10 = uicontrol('Style', 'pushbutton', 'String', 'Exit',...
    'Units','normalized', ...
    'Position',[ 0.0 0 0.1 0.05], ...  
    'Callback', 'global LUSER1 LUSER2 LUSER3 LUSER4 LICEN; close(LICEN);');
end
