fid = fopen(['scriptgop.m'],'w');
fprintf(fid,['gopscr\n']);
fprintf(fid,['\n']);
fprintf(fid,['%%****************************\n']);
fprintf(fid,['%%* GOP variables definition *\n']);
fprintf(fid,['%%****************************\n']);
fprintf(fid,['%%General Algorithm Options\n']);
fprintf(fid,['%%*****************************\n']);
fprintf(fid,['spinit=' num2str(spinit) ';\n']);
fprintf(fid,['epsijs=' num2str(epsijs) ';\n']);
fprintf(fid,['stopcrit=' num2str(stopcrit) ';\n']);
fprintf(fid,['reachpoint=' num2str(reachpoint) ';\n']);
fprintf(fid,['evalumax=' num2str(evalumax) ';\n']);  
fprintf(fid,['%%Core Optimization Method Options\n']);
fprintf(fid,['%%***********************************\n']);
fprintf(fid,['mopt=' num2str(mopt) ';\n']);;
fprintf(fid,['goppar=' num2str(goppar) ';\n']);;
fprintf(fid,['%%*** GOP DESCENT OPTIONS\n']);
fprintf(fid,['nbgrad=' num2str(nbgrad) ';\n']);
fprintf(fid,['method=' num2str(method) ';\n']);
fprintf(fid,['retdm=' num2str(retdm) ';\n']);
fprintf(fid,['normgrad=' num2str(normgrad) ';\n']);
fprintf(fid,['conj=' num2str(conj) ';\n']);
fprintf(fid,['gam200=' num2str(gam200) ';\n']);
fprintf(fid,['gamdeg=' num2str(gamdeg) ';\n']);
fprintf(fid,['iordre=' num2str(iordre) ';\n']);
fprintf(fid,['epsfd=' num2str(epsfd) ';\n']);
fprintf(fid,['rho00=' num2str(rho00) ';\n']);
fprintf(fid,['autorho=' num2str(autorho) ';\n']);
fprintf(fid,['srho=' num2str(srho) ';\n']);
fprintf(fid,['initcond2=' num2str(initcond2) ';\n']);
fprintf(fid,['%%*** MATLAB METHODS OPTIONS\n']);
fprintf(fid,['mtool=' num2str(mtool) ';\n']);
fprintf(fid,['mateval=' num2str(mateval) ';\n']);
fprintf(fid,['iordre=' num2str(iordre) ';\n']);
fprintf(fid,['epsfd=' num2str(epsfd) ';\n']);
fprintf(fid,['hess=' num2str(hess) ';\n']);
fprintf(fid,['mopt2=' num2str(mopt2) ';\n']);
fprintf(fid,['mopt3=' num2str(mopt3) ';\n']);
fprintf(fid,['%%*** GA OPTIONS\n']);
fprintf(fid,['gaver=' num2str(gaver) ';\n']); 
fprintf(fid,['Npop=' num2str(Npop) ';\n']); 
fprintf(fid,['Ngen=' num2str(Ngen) ';\n']); 
fprintf(fid,['pm=' num2str(pm) ';\n']); 
fprintf(fid,['pc=' num2str(pc) ';\n']);
fprintf(fid,['Refb=' num2str(Refb) ';\n']);
fprintf(fid,['%%*** CRS OPTIONS\n']);
fprintf(fid,['Npop=' num2str(Npop) ';\n']); 
fprintf(fid,['CRSMAX=' num2str(CRSMAX) ';\n']); 
fprintf(fid,['pm=' num2str(CRSpm) ';\n']); 
fprintf(fid,['%%Multi-Layer Algorithm Options\n']);
fprintf(fid,['%%*****************************\n']);
fprintf(fid,['icoa=' num2str(icoa) ';\n']);
fprintf(fid,['nbext1=' num2str(nbext1) ';\n']);
fprintf(fid,['nbext2=' num2str(nbext2) ';\n']);
fprintf(fid,['nbbvp=' num2str(nbbvp) ';\n']); 
fprintf(fid,['calsec=' num2str(calsec) ';\n']);
fprintf(fid,['methodt=' num2str(methodt) ';\n']);
fprintf(fid,['radb=' num2str(radb) ';\n']);
fprintf(fid,['avrep=' num2str(avrep) ';\n']);
fprintf(fid,['%%Output Options\n']);
fprintf(fid,['%%*****************************\n']);
fprintf(fid,['savedir=''' savedir '''' ';\n']);
fprintf(fid,['fsdate=' num2str(fsdate) ';\n']);
fprintf(fid,['fileresult=''' fileresult '''' ';\n']);
fprintf(fid,['fileconv=''' fileconv '''' ';\n']);
fprintf(fid,['filebconv=''' filebconv '''' ';\n']);
fprintf(fid,['savefile=' num2str(savefile) ';\n']);
fprintf(fid,['elevo=''' elevo '''' ';\n']);
fprintf(fid,['login=' num2str(login) ';\n']);
fprintf(fid,['filefilm=''' filefilm '''' ';\n']);
fprintf(fid,['mailto=''' mailto '''' ';\n']);
fprintf(fid,['%%Processing Options\n']);
fprintf(fid,['%%*****************************\n']);
fprintf(fid,['savemem=' num2str(savemem) ';\n']);
fprintf(fid,['teste=' num2str(teste) ';\n']);
fprintf(fid,['pausette=' num2str(pausette) ';\n']);
fprintf(fid,['passerr=' num2str(passerr) ';\n']);
fprintf(fid,['passerrval=' num2str(passerrval) ';\n']);
fprintf(fid,['\n']);
fprintf(fid,['gopoptsum\n']);
fprintf(fid,['\n']);
fprintf(fid,['%%goprun %%To run GOP, remove the first comment percent of this line\n']);
fclose(fid);