figure3=figure( ...
       'Name','GOP : Convergence', ...
       'NumberTitle','off', ...
       'Visible','off');

axis on

 faxcv = get(gcf,'Children');
  set(faxcv,...
      'Units','normalized', ...
      'Visible','on', ...
      'Position',[0.1 0.2 0.8 0.8]);  

     
PCOVG=uibuttongroup('Position',[ 0 0.0 1 0.1]);

PCOVG2=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.01 0.01 0.9 0.08], ...
      'String','CONVERGENCE OPTIONS');  
  
PCOV = uicontrol('Style', 'pushbutton', 'String', 'Draw',...
    'Units','normalized', ...
    'Position',[ 0.01 0.01 0.1 0.05], ...  
    'Tooltipstring','Start/Restart drawing function', ...
    'Callback', 'figure(figure3);cla;colorbar(''off'');try; hold on;plot(xcoor,conv,xcoor,bestconv);ylabel(''Value of J'');xlabel(''Iteration'');hold off; end;legend(''Convergence History'',''Convergence of the best solution'') ;');

PCVAG = uicontrol('Style', 'pushbutton', 'String', 'Stat. GA',...  
    'Units','normalized', ...
    'Position',[ 0.11 0.01 0.1 0.05], ...  
    'Tooltipstring','Start/Restart drawing function', ...
    'Callback', 'figure(figure3);cla;legend(''off'');try; hold on;surface(agstat,''EdgeColor'',''none'');ylabel(''Population'');xlabel(''Iteration'');colorbar;hold off; end;');

PCVAG2 = uicontrol('Style', 'pushbutton', 'String', 'Mean GA',...  
    'Units','normalized', ...
    'Position',[ 0.21 0.01 0.1 0.05], ...  
    'Tooltipstring','Start/Restart drawing function', ...
    'Callback', 'figure(figure3);cla;legend(''off'');try; hold on;plot(agmstat);xlabel(''Iteration'');ylabel(''Value of J'');legend(''Population Mean Value'');hold off; end;');
    
if (mopt==4)
    set(PCVAG,'Visible','on'); 
    set(PCVAG2,'Visible','on'); 
  else
     set(PCVAG,'Visible','off'); 
      set(PCVAG2,'Visible','off'); 
  end