%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Fenetre SURACE
figure5=figure( ...
       'Name','GOP : Responce surface', ...
       'NumberTitle','off', ...
       'Visible','off');
axis on
 faxsr = get(gcf,'Children');
  set(faxsr,...
      'Units','normalized', ...
      'Visible','on', ...
      'Position',[0.1 0.2 0.8 0.8]);
 
figure(figure5)
 SRC11=uibuttongroup('Position',[ 0. 0. 1. 0.13]);
  
   
SRdim = uicontrol('Style', 'pushbutton', 'String', 'Dim 2',...
    'Units','normalized', ...
    'Position',[ 0.01 0.07 0.1 0.05], ...  
    'Tooltipstring','Choose dimension of response surface', ...
    'Callback', 'guic=9010;gopaction;'); 

SRdraw = uicontrol('Style', 'pushbutton', 'String', 'DrawSR',...
    'Units','normalized', ...
    'Position',[ 0.01 0.02 0.1 0.05], ...  
    'Tooltipstring','Start/Restart drawing function', ...
    'Callback', 'gopdrawsr;');
csr=.055;
SR11=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.15+csr 0.02 0.10 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'Tooltipstring','Choose the i dimension corresponding to parameter 1', ...
      'String', 'Param 1'); 
SR12=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.25+csr 0.02 0.06 0.05], ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'String', xsr1 );
SR13 = uicontrol('Style', 'pushbutton', 'String', '+',...
    'Units','normalized', ...
    'Position',[ 0.31+csr 0.05 0.02 0.02], ...  
    'Callback', 'guic=9001;gopaction;');  
SR14 = uicontrol('Style', 'pushbutton', 'String', '-',...
    'Units','normalized', ...
    'Position',[ 0.31+csr 0.028 0.02 0.02], ...  
    'Callback', 'guic=9002;gopaction;'); 
SR21=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.35+csr 0.02 0.10 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'Tooltipstring','Choose the i dimension corresponding to parameter 2', ...
      'String', 'Param 2'); 
SR22=uicontrol( ...
     'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.45+csr 0.02 0.06 0.05], ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'String', xsr2 );
SR23 = uicontrol('Style', 'pushbutton', 'String', '+',...
    'Units','normalized', ...
    'Position',[ 0.51+csr 0.05 0.02 0.02], ...  
    'Callback', 'guic=9003;gopaction;');  
SR24 = uicontrol('Style', 'pushbutton', 'String', '-',...
    'Units','normalized', ...
    'Position',[ 0.51+csr 0.028 0.02 0.02], ...  
    'Callback', 'guic=9004;gopaction;'); 


SR41=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.55+csr 0.02 0.10 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'Tooltipstring','Choose the i dimension corresponding to parameter 3', ...
      'String', 'Param 3'); 
SR42=uicontrol( ...
     'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.65+csr 0.02 0.06 0.05], ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'String', xsr3 );
SR43 = uicontrol('Style', 'pushbutton', 'String', '+',...
    'Units','normalized', ...
    'Position',[ 0.71+csr 0.05 0.02 0.02], ...  
    'Callback', 'guic=9007;gopaction;');  
SR44 = uicontrol('Style', 'pushbutton', 'String', '-',...
    'Units','normalized', ...
    'Position',[ 0.71+csr 0.028 0.02 0.02], ...  
    'Callback', 'guic=9008;gopaction;'); 
if (ndim<=2)
    set(SR41,'Visible','off');
    set(SR42,'Visible','off');
    set(SR43,'Visible','off');
    set(SR44,'Visible','off');
end
if (ndim==1)
    set(SR21,'Visible','off');
    set(SR22,'Visible','off');
    set(SR23,'Visible','off');
    set(SR24,'Visible','off');
end
SR311 = uicontrol('Style', 'pushbutton', 'String', 'Ed. SRP',...
    'Units','normalized', ...
    'Position',[ 0.11 0.07 0.1 0.05], ...  
    'Tooltipstring','Start/Restart drawing function', ...
    'Callback', 'openvar xsr;');
SR31=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.75+csr 0.02 0.10 0.05], ...
      'ForegroundColor',[0 0 0], ...
      'Tooltipstring','Contour precision', ...
      'String', 'Draw P.'); 
SR32=uicontrol( ...
      'Style','text', ...
      'Units','normalized', ...
      'Position',[ 0.85+csr 0.02 0.06 0.05], ...
      'BackgroundColor',[1 1 1], ...
      'ForegroundColor',[0 0 0], ...
      'String', precisr );
SR33 = uicontrol('Style', 'pushbutton', 'String', '+',...
    'Units','normalized', ...
    'Position',[ 0.91+csr 0.05 0.02 0.02], ...  
    'Callback', 'guic=9005;gopaction;');  
SR34 = uicontrol('Style', 'pushbutton', 'String', '-',...
    'Units','normalized', ...
    'Position',[ 0.91+csr 0.028 0.02 0.02], ...  
    'Callback', 'guic=9006;gopaction;'); 
