
 License=['Free user - GNU General Public License - Non profit use'];
  Messd='';
    a=exist('userinit.m');
    b=exist('userfunc.m');

    if (typecomp==2)
        b=exist('external.exe');
        a=exist('Init.dat');
    end

 
    if (gopgui==1)
        scrsz = get(0,'ScreenSize');
        Li=figure( ...
            'Position',[0 0  scrsz(3) scrsz(4)],...
            'Name',' ', ...
            'NumberTitle','off', ...
            'Visible','on',...
            'MenuBar','none');
%         try
%         text(-5.5,5.5,'Global Optimization Platform','FontSize',floor((scrsz(3)+scrsz(4))/38));
%         text(-5,-6.1,[probstr '-'  License],'FontSize',(floor((scrsz(3)+scrsz(4))/38))/2);
%         text(1.1,-3,'Ivorra Benjamin (Universidad Complutense Madrid)','FontSize',(floor((scrsz(3)+scrsz(4))/38))/4);
%         text(1.35,-3.5,'Angel Ramos (Universidad Complutense Madrid)','FontSize',(floor((scrsz(3)+scrsz(4))/38))/4);
%         text(1.8,-4,'Bijan Mohammadi (Universit Montpellier II)','FontSize',(floor((scrsz(3)+scrsz(4))/38))/4);
%         end
% 
%         axis on;
%         fax = get(gcf,'Children');
%         set(fax, 'Units','normalized');
%         axis off;
%         xxfig=[];yyfig=[];zzfig=[];
%         xfi=-4:.1:3;
%         yfi=-4:.1:3;
%         [xxfig,yyfig]=meshgrid(xfi,yfi);
%         for i=1:length(xfi)
%             for j=1:length(yfi)
%                 zzfig(i,j)=sin(xxfig(i*length(xfi)))+sin(2*yyfig(j))+(yyfig(j)+1)^2/4;
%             end
%         end
%        
%         surf1=surface(xxfig,yyfig,zzfig,'EdgeColor',[.8 .8 .8],'FaceColor','interp');
%         line([1.1 2.5 -.5],[1.7 -3 -3],[3 3 1],'LineWidth',5,'Color','Black');
% 
% try
%         text(1.,1.7,3,'\bullet', ...
%             'Color',[0. 0. 1.], ...
%             'FontSize',floor((scrsz(3)+scrsz(4))/38) , ...
%             'EraseMode','none');
% 
%         text(2.35,-3,3.1,'\bullet', ...
%             'Color',[1. 0. 0.], ...
%             'FontSize',floor((scrsz(3)+scrsz(4))/38), ...
%             'EraseMode','none');
% 
%         text(-.6,-3,1.1,'\bullet', ...
%             'Color',[0. 1. 0.], ...
%             'FontSize',floor((scrsz(3)+scrsz(4))/38), ...
%             'EraseMode','none');
% end
%         view(10,55);
% 
%         %[aa,bb] = imread('petitlogo.gif','gif');
%         %b2 = [bb; 1 1 1];
%         %image(uint8(aa)), colormap(b2)
goptit=imread('goptitle','jpg');
image(goptit)
set(gca,'Position',[0,0,1,1])
            text(1040,140,[probstr],'FontSize',(floor((scrsz(3)+scrsz(4))/38))/2);

            axis off

        try
            waitforbuttonpress
        end
        try
            set(Li,'Visible','off')
        end
    end

           gopinit


        if (gopgui==1)

            try
                userinterface
            end
            gopguim
            %Default option
            guic=772;gopaction %Matlab
            guic=1;gopaction %Grad
            guic=741;gopaction %Conjugate
            guic=687;gopaction %Fmincon
  %          guic=742;gopaction %Grad
  %          guic=742;gopaction %Grad
            if (exist('usergrad.m')==2)
                guic=742;gopaction %Grad
            end
            if (ndim==2)
                guic=499;gopaction %Grad
                guic=500;gopaction %Grad
                guic=501;gopaction %Grad
                guic=502;gopaction %Grad
                verifsav=1;
            end
            act=[];
        end
    

        
        
    if (a*b==0)
 
        try
            close(Messd)
        end
        
        Mess=['The following optimization problem files doesn''t exist in the current directory:'];
        if (typecomp==2)
            if (a==0) Mess=[Mess '  -  Init.dat : Initials conditions'];end
            if (b==0) Mess=[Mess '  -  external.exe : Function'];end
        else
            if (a==0) Mess=[Mess '  -  userinit.m : Initials conditions'];end
            if (b==0) Mess=[Mess '  -  userfunc.m : Function'];end
        end
        if (gopgui==1)
            Messd=questdlg(Mess,'Missing problem files','Ignore and continue ','Create a New Project','Go to a Demo Problem','Ignore');
        else
            disp(['Warning: ' Mess]);
            disp(' ');
        end
        try
            
        if isempty(Messd)
            Messd=['Ignore and continue '];
        end
        end
        
        if (Messd=='Create a New Project')
            answer = inputdlg('Enter the new projects folder name','Project Name');
            try
                answer = char(answer);
                mkdir(answer)
                cd(answer)
                copyfile([GOPdir '\GOP-Sources\gopuserinitvid.m'],'userinit.m')
                copyfile([GOPdir '\GOP-Sources\gopuserfuncvid.m'],'userfunc.m')
                open('userfunc.m')
                open('userinit.m')
                msgbox('Project created successfully. Please complete Userfunc.m and Userinit.m files...','Project created')
                set (PGB1,'Visible','on')

            catch
                errordlg('Error during project creation. Please verify your GOP installation...','ERROR');
            end
            
        end
            if (Messd=='Go to a Demo Problem')
                try
                    cd([GOPdir '\GOP-Demos-Matlab'])
                    d = dir;
                    str = {d.name};
                    str=str(3:end);
                    pos = listdlg('PromptString','Select a demonstration problem:',...
                        'SelectionMode','single',...
                        'ListString',str);
                      if (isempty(char(str(pos)))==0)
                    cd(char(str(pos)));
                    end
                    guic=-100;gopaction;
                catch
                    errordlg('Error during demo selection. Please verify your GOP installation...','ERROR');
                end

            end
     
        end


